from SmartSectionElement              import SmartSectionElement
from Products.SmartComponents.Globals import findFormRoot
from Products.Formulator              import StandardFields
from Products.SmartForms              import HTMLForm
from Products.Formulator.Form         import FormValidationError

import time, string


def manage_addSmartLinkForm(self, REQUEST):
    ''' '''
    root = findFormRoot(self)
    if not hasattr(root, 'edit_SmartLinkForm'):
        form = HTMLForm.HTMLForm('edit_SmartLinkForm', 'Edit Form for Smart Links')
        form.manage_changeProperties(addAction  = 'manage_addSmartLink',
                                     editAction = 'manage_changeProperties')

        form._setObject('file', StandardFields.FileField(
            "file",
            title         = "File",
            required      = 1,
            display_width = 40,
            max_length    = 1000) )

        form._setObject('check', StandardFields.CheckBoxField(
            "check",
            title         = "Check Link",
            required      = 1,
            default       = 1) )

        form._setObject('linktype', StandardFields.ListField(
            'linktype',
            title='Type of Link',
            default="external",
            size=1,
            items=[('External Link', 'external'),
                   ('Internal Link', 'internal'),
                   ('Relative Link', 'relative')],
            required=1) )

        form._setObject('text', StandardFields.StringField(
            "text",
            title         = "Text",
            required      = 0,
            display_width = 40,
            max_length    = 1000) )

        form._setObject('cssClass', StandardFields.StringField(
            "cssClass",
            title         = "CSS Class",
            required      = 0,
            display_width = 40,
            max_length    = 1000) )

        root._setObject('edit_SmartLinkForm', form)

    REQUEST.set('mode', 'Add')
    return root.edit_SmartLinkForm.renderMethod(root.edit_SmartLinkForm, REQUEST)


def manage_addSmartLink(self, id='', title='', REQUEST=None):
    ''' '''

    try:
        result = self.edit_SmartLinkForm.validate_all(REQUEST)
    except FormValidationError, e:
            messages = ["Validation error(s)"]
            for error in e.errors:
                messages.append("%s: %s" % (error.field.get_value('title'),
                                            error.error_text))
            message = string.join(messages, "<br>")
            return self.edit_SmartLinkForm.renderMethod(self.edit_SmartLinkForm, REQUEST,
                                                          manage_tabs_message=message)


    if not id: id  = str(int(time.time()))
    
    header = SmartLink(id, title, result)
    self._setObject(id, header)


    if REQUEST:
        return self.manage_main(self, REQUEST)


class SmartLink(SmartSectionElement):
    ''' '''

    meta_type = 'Smart Link'
    icon = 'misc_/SmartSections/Link'

    _properties= ( {'id': 'link',     'type': 'string', 'mode': 'w', 'default': ''      },
                   {'id': 'text',     'type': 'string', 'mode': 'w', 'default': ''      },
                   {'id': 'cssClass', 'type': 'string', 'mode': 'w', 'default': 'header'} )
                   
    renderText = '''--> <a href="%(link)s" class="%(cssClass)s">%(text)s</a>'''





