from General                          import findFormContainer
from HTMLForm                         import HTMLForm
from SmartSectionElement              import SmartSectionElement, manage_addSectionElement
from Products.Formulator              import StandardFields

import time, string


def manage_addSmartSeparatorForm(self, REQUEST):
    ''' '''
    root = findFormContainer(self)
    if not hasattr(root, 'edit_SmartSeparatorForm'):
        form = HTMLForm('edit_SmartSeparatorForm', 'Edit Form for Smart Separators')
        form.manage_changeProperties(addAction  = 'manage_addSmartSeparator',
                                     editAction = 'manage_edit_properties')

        form._setObject('size', StandardFields.ListField(
            'size',
            title='Size',
            default=1,
            size=1,
            items=[('Thin',   1), ('Thinner',  2),
                   ('Medium', 3), ('Thicker',  4),
                   ('Thick',  5), ('Thickest', 6)],
            required=1) )

        form._setObject('width', StandardFields.StringField(
            "width",
            title         = "Width of line",
            required      = 0,
            display_width = 5,
            max_length    = 5) )

        form._setObject('cssClass', StandardFields.StringField(
            "cssClass",
            title         = "CSS Class",
            required      = 0,
            display_width = 40,
            max_length    = 1000) )

        root._setObject('edit_SmartSeparatorForm', form)

    REQUEST.set('mode', 'add')
    form = root.edit_SmartSeparatorForm
    return form.renderMethod(form, REQUEST)


def manage_addSmartSeparator(self, id='', title='', nextURL='', position=0, REQUEST=None):
    ''' '''
    return manage_addSectionElement(self, SmartSeparator, id, title, nextURL, position, REQUEST)


class SmartSeparator(SmartSectionElement):
    ''' '''

    meta_type = 'Smart Separator'
    icon = 'misc_/SmartSections/Separator'

    _properties= ( {'id': 'size',     'type': 'int',    'mode': 'w', 'default': 1          },
                   {'id': 'width',    'type': 'string', 'mode': 'w', 'default': '95%'      },
                   {'id': 'cssClass', 'type': 'string', 'mode': 'w', 'default': 'separator'} )
                   
    renderText = '''<hr size=%(size)s width="%(width)s" class="%(cssClass)s" align="left" noshade>'''



