from FolderishSmartSectionElement         import FolderishSmartSectionElement
from SmartSectionElement                  import manage_addSectionElement
from General                              import findFormContainer
from HTMLForm                             import HTMLForm
from Products.Formulator                  import StandardFields
from Products.Formulator.Form             import FormValidationError
from Products.OrderedFolder.OrderedFolder import OrderedFolder

import SmartHeaderRow, SmartRow

import time, string


def manage_addSmartTableForm(self, REQUEST):
    ''' '''
    root = findFormContainer(self)
    if not hasattr(root, 'edit_SmartTableForm'):
        form = HTMLForm('edit_SmartTableForm', 'Edit Form for Smart Tables')
        form.manage_changeProperties(addAction  = 'manage_addSmartTable',
                                     editAction = 'manage_edit_properties')
        root._setObject('edit_SmartTableForm', form)

        form._setObject('cols', StandardFields.IntegerField(
            'cols',
            title   = 'Number of Columns',
            default = 2,
            start   = 0,
            end     = 15,
            display_width = 2,
            required = 1) )

        form._setObject('border', StandardFields.ListField(
            'border',
            title='Border',
            default=1,
            size=1,
            items=[('None',   0),
                   ('Thin',   1), ('Thinner',  2),
                   ('Medium', 3), ('Thicker',  4),
                   ('Thick',  5), ('Thickest', 6)],
            required=1) )

        form._setObject('width', StandardFields.StringField(
            "width",
            title         = "Width of Table",
            required      = 0,
            display_width = 5,
            max_length    = 5) )

        form._setObject('cssClass', StandardFields.StringField(
            "cssClass",
            title         = "CSS Class",
            required      = 0,
            display_width = 40,
            max_length    = 1000) )

    REQUEST.set('mode', 'add')
    form = root.edit_SmartTableForm
    return form.renderMethod(form, REQUEST)
    

from SmartHeaderRow import manage_addSmartHeaderRow
from SmartRow       import manage_addSmartRow

def manage_addSmartTable(self, id='', title='', nextURL='', position=0, REQUEST=None, returnId=0):
    ''' '''
    id = manage_addSectionElement(self, SmartTable, id, title, '', position, REQUEST, 1)
    table = getattr(self, id)
    time.sleep(0.01)
    manage_addSmartHeaderRow(table, REQUEST=REQUEST)

    if nextURL:
        REQUEST.RESPONSE.redirect(nextURL)
    elif returnId:
        return id
    elif REQUEST:
        return REQUEST.RESPONSE.redirect('../manage_main')



class SmartTable(FolderishSmartSectionElement):
    ''' '''

    meta_type = 'Smart Table'
    icon = 'misc_/SmartSections/Table'

    _properties= ( {'id': 'cols',     'type': 'int',    'mode': 'w', 'default': 2          },
                   {'id': 'border',   'type': 'int',    'mode': 'w', 'default': 1          },
                   {'id': 'width',    'type': 'string', 'mode': 'w', 'default': '95%'      },
                   {'id': 'cssClass', 'type': 'string', 'mode': 'w', 'default': 'separator'} )


    _meta_types = ( { 'name': 'Smart Row',
                      'action': 'manage_addSmartRowForm'},
                    { 'name': 'Smart Header Row',
                      'action': 'manage_addSmartHeaderRowForm'} )

    manage_addSmartRowForm = SmartRow.manage_addSmartRowForm
    manage_addSmartRow     = SmartRow.manage_addSmartRow
    manage_addSmartHeaderRowForm = SmartHeaderRow.manage_addSmartHeaderRowForm
    manage_addSmartHeaderRow     = SmartHeaderRow.manage_addSmartHeaderRow

    renderText = ( '<table width="%(width)s" cols="%(cols)s" border="%(border)s" class="%(cssClass)s">\n' +
                   '  %(content)s' +
                   '</table>' )


    old_render = FolderishSmartSectionElement.render

    def render(self, mode='view'):
        ''' '''
        dict = self.__dict__.copy()
        dict['content'] = self.old_render(mode)
        if mode == 'edit':
            dict['cols'] = int(self.cols) + 1
        return self.renderText %dict


