from SmartSectionElement              import SmartSectionElement, manage_addSectionElement
from General                          import findFormContainer
from HTMLForm                         import HTMLForm
from Products.Formulator              import StandardFields
from Products.Formulator.Form         import FormValidationError

import time, string


def manage_addSmartTextBlockForm(self, REQUEST):
    ''' '''
    root = findFormContainer(self)
    if not hasattr(root, 'edit_SmartTextBlockForm'):
        form = HTMLForm('edit_SmartTextBlockForm', 'Edit Form for Smart TextBlocks')
        form.manage_changeProperties(addAction  = 'manage_addSmartTextBlock',
                                     editAction = 'manage_edit_properties')

        form._setObject('text', StandardFields.TextAreaField(
            "text",
            title         = "Text",
            required      = 0,
            width         = 60,
            height        = 7) )

        form._setObject('cssClass', StandardFields.StringField(
            "cssClass",
            title         = "CSS Class",
            required      = 0,
            display_width = 40,
            max_length    = 1000) )

        root._setObject('edit_SmartTextBlockForm', form)

    REQUEST.set('mode', 'add')
    form = root.edit_SmartTextBlockForm
    return form.renderMethod(form, REQUEST)


def manage_addSmartTextBlock(self, id='', title='', nextURL='', position=0, REQUEST=None, returnId=0):
    ''' '''
    return manage_addSectionElement(self, SmartTextBlock, id, title, nextURL, position, REQUEST, returnId)


class SmartTextBlock(SmartSectionElement):
    ''' '''

    meta_type = 'Smart TextBlock'
    icon = 'misc_/SmartSections/HTMLBlock'

    _properties= ( {'id': 'text',     'type': 'string', 'mode': 'w', 'default': ''      },
                   {'id': 'cssClass', 'type': 'string', 'mode': 'w', 'default': 'text'} )
                   
    renderText = '''<p class="%(cssClass)s">%(text)s</p>'''
